test(junit): avoid line feeds in XML attributes
[git/debian.git] / t / test-lib.sh
blobbdb11e28eeaf3b8cb7bfd142e4df3b8a5128792e
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # ensure that TEST_DIRECTORY is an absolute path so that it
23 # is valid even if the current working directory is changed
24 TEST_DIRECTORY=$(pwd)
25 else
26 # The TEST_DIRECTORY will always be the path to the "t"
27 # directory in the git.git checkout. This is overridden by
28 # e.g. t/lib-subtest.sh, but only because its $(pwd) is
29 # different. Those tests still set "$TEST_DIRECTORY" to the
30 # same path.
32 # See use of "$GIT_BUILD_DIR" and "$TEST_DIRECTORY" below for
33 # hard assumptions about "$GIT_BUILD_DIR/t" existing and being
34 # the "$TEST_DIRECTORY", and e.g. "$TEST_DIRECTORY/helper"
35 # needing to exist.
36 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
38 if test -z "$TEST_OUTPUT_DIRECTORY"
39 then
40 # Similarly, override this to store the test-results subdir
41 # elsewhere
42 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
44 GIT_BUILD_DIR="${TEST_DIRECTORY%/t}"
45 if test "$TEST_DIRECTORY" = "$GIT_BUILD_DIR"
46 then
47 echo "PANIC: Running in a $TEST_DIRECTORY that doesn't end in '/t'?" >&2
48 exit 1
51 # Prepend a string to a VAR using an arbitrary ":" delimiter, not
52 # adding the delimiter if VAR or VALUE is empty. I.e. a generalized:
54 # VAR=$1${VAR:+${1:+$2}$VAR}
56 # Usage (using ":" as the $2 delimiter):
58 # prepend_var VAR : VALUE
59 prepend_var () {
60 eval "$1=$3\${$1:+${3:+$2}\$$1}"
63 # If [AL]SAN is in effect we want to abort so that we notice
64 # problems. The GIT_SAN_OPTIONS variable can be used to set common
65 # defaults shared between [AL]SAN_OPTIONS.
66 prepend_var GIT_SAN_OPTIONS : abort_on_error=1
67 prepend_var GIT_SAN_OPTIONS : strip_path_prefix=\"$GIT_BUILD_DIR/\"
69 # If we were built with ASAN, it may complain about leaks
70 # of program-lifetime variables. Disable it by default to lower
71 # the noise level. This needs to happen at the start of the script,
72 # before we even do our "did we build git yet" check (since we don't
73 # want that one to complain to stderr).
74 prepend_var ASAN_OPTIONS : $GIT_SAN_OPTIONS
75 prepend_var ASAN_OPTIONS : detect_leaks=0
76 export ASAN_OPTIONS
78 prepend_var LSAN_OPTIONS : $GIT_SAN_OPTIONS
79 prepend_var LSAN_OPTIONS : fast_unwind_on_malloc=0
80 export LSAN_OPTIONS
82 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
83 then
84 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
85 exit 1
87 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
88 export PERL_PATH SHELL_PATH
90 # In t0000, we need to override test directories of nested testcases. In case
91 # the developer has TEST_OUTPUT_DIRECTORY part of his build options, then we'd
92 # reset this value to instead contain what the developer has specified. We thus
93 # have this knob to allow overriding the directory.
94 if test -n "${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
95 then
96 TEST_OUTPUT_DIRECTORY="${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
99 # Disallow the use of abbreviated options in the test suite by default
100 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
101 then
102 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
103 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
106 # Explicitly set the default branch name for testing, to avoid the
107 # transitory "git init" warning under --verbose.
108 : ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
109 export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
111 ################################################################
112 # It appears that people try to run tests without building...
113 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
114 if test $? != 1
115 then
116 if test -n "$GIT_TEST_INSTALLED"
117 then
118 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
119 else
120 echo >&2 'error: you do not seem to have built git yet.'
122 exit 1
125 store_arg_to=
126 opt_required_arg=
127 # $1: option string
128 # $2: name of the var where the arg will be stored
129 mark_option_requires_arg () {
130 if test -n "$opt_required_arg"
131 then
132 echo "error: options that require args cannot be bundled" \
133 "together: '$opt_required_arg' and '$1'" >&2
134 exit 1
136 opt_required_arg=$1
137 store_arg_to=$2
140 # These functions can be overridden e.g. to output JUnit XML
141 start_test_output () { :; }
142 start_test_case_output () { :; }
143 finalize_test_case_output () { :; }
144 finalize_test_output () { :; }
146 parse_option () {
147 local opt="$1"
149 case "$opt" in
150 -d|--d|--de|--deb|--debu|--debug)
151 debug=t ;;
152 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
153 immediate=t ;;
154 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
155 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
157 mark_option_requires_arg "$opt" run_list
159 --run=*)
160 run_list=${opt#--*=} ;;
161 -h|--h|--he|--hel|--help)
162 help=t ;;
163 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
164 verbose=t ;;
165 --verbose-only=*)
166 verbose_only=${opt#--*=}
168 -q|--q|--qu|--qui|--quie|--quiet)
169 # Ignore --quiet under a TAP::Harness. Saying how many tests
170 # passed without the ok/not ok details is always an error.
171 test -z "$HARNESS_ACTIVE" && quiet=t ;;
172 --with-dashes)
173 with_dashes=t ;;
174 --no-bin-wrappers)
175 no_bin_wrappers=t ;;
176 --no-color)
177 color= ;;
178 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
179 valgrind=memcheck
180 tee=t
182 --valgrind=*)
183 valgrind=${opt#--*=}
184 tee=t
186 --valgrind-only=*)
187 valgrind_only=${opt#--*=}
188 tee=t
190 --tee)
191 tee=t ;;
192 --root=*)
193 root=${opt#--*=} ;;
194 --chain-lint)
195 GIT_TEST_CHAIN_LINT=1 ;;
196 --no-chain-lint)
197 GIT_TEST_CHAIN_LINT=0 ;;
199 trace=t ;;
200 -V|--verbose-log)
201 verbose_log=t
202 tee=t
204 --write-junit-xml)
205 . "$TEST_DIRECTORY/test-lib-junit.sh"
207 --stress)
208 stress=t ;;
209 --stress=*)
210 echo "error: --stress does not accept an argument: '$opt'" >&2
211 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
212 exit 1
214 --stress-jobs=*)
215 stress=t;
216 stress_jobs=${opt#--*=}
217 case "$stress_jobs" in
218 *[!0-9]*|0*|"")
219 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
220 exit 1
222 *) # Good.
224 esac
226 --stress-limit=*)
227 stress=t;
228 stress_limit=${opt#--*=}
229 case "$stress_limit" in
230 *[!0-9]*|0*|"")
231 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
232 exit 1
234 *) # Good.
236 esac
239 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
240 esac
243 # Parse options while taking care to leave $@ intact, so we will still
244 # have all the original command line options when executing the test
245 # script again for '--tee' and '--verbose-log' later.
246 for opt
248 if test -n "$store_arg_to"
249 then
250 eval $store_arg_to=\$opt
251 store_arg_to=
252 opt_required_arg=
253 continue
256 case "$opt" in
257 --*|-?)
258 parse_option "$opt" ;;
259 -?*)
260 # bundled short options must be fed separately to parse_option
261 opt=${opt#-}
262 while test -n "$opt"
264 extra=${opt#?}
265 this=${opt%$extra}
266 opt=$extra
267 parse_option "-$this"
268 done
271 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
272 esac
273 done
274 if test -n "$store_arg_to"
275 then
276 echo "error: $opt_required_arg requires an argument" >&2
277 exit 1
280 if test -n "$valgrind_only"
281 then
282 test -z "$valgrind" && valgrind=memcheck
283 test -z "$verbose" && verbose_only="$valgrind_only"
284 elif test -n "$valgrind"
285 then
286 test -z "$verbose_log" && verbose=t
289 if test -n "$stress"
290 then
291 verbose=t
292 trace=t
293 immediate=t
296 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
297 TEST_NAME="$(basename "$0" .sh)"
298 TEST_NUMBER="${TEST_NAME%%-*}"
299 TEST_NUMBER="${TEST_NUMBER#t}"
300 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
301 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
302 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
303 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
304 case "$TRASH_DIRECTORY" in
305 /*) ;; # absolute path is good
306 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
307 esac
309 # If --stress was passed, run this test repeatedly in several parallel loops.
310 if test "$GIT_TEST_STRESS_STARTED" = "done"
311 then
312 : # Don't stress test again.
313 elif test -n "$stress"
314 then
315 if test -n "$stress_jobs"
316 then
317 job_count=$stress_jobs
318 elif test -n "$GIT_TEST_STRESS_LOAD"
319 then
320 job_count="$GIT_TEST_STRESS_LOAD"
321 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
322 test -n "$job_count"
323 then
324 job_count=$((2 * $job_count))
325 else
326 job_count=8
329 mkdir -p "$TEST_RESULTS_DIR"
330 stressfail="$TEST_RESULTS_BASE.stress-failed"
331 rm -f "$stressfail"
333 stress_exit=0
334 trap '
335 kill $job_pids 2>/dev/null
336 wait
337 stress_exit=1
338 ' TERM INT HUP
340 job_pids=
341 job_nr=0
342 while test $job_nr -lt "$job_count"
345 GIT_TEST_STRESS_STARTED=done
346 GIT_TEST_STRESS_JOB_NR=$job_nr
347 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
349 trap '
350 kill $test_pid 2>/dev/null
351 wait
352 exit 1
353 ' TERM INT
355 cnt=1
356 while ! test -e "$stressfail" &&
357 { test -z "$stress_limit" ||
358 test $cnt -le $stress_limit ; }
360 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
361 test_pid=$!
363 if wait $test_pid
364 then
365 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
366 else
367 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
368 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
370 cnt=$(($cnt + 1))
371 done
373 job_pids="$job_pids $!"
374 job_nr=$(($job_nr + 1))
375 done
377 wait
379 if test -f "$stressfail"
380 then
381 stress_exit=1
382 echo "Log(s) of failed test run(s):"
383 for failed_job_nr in $(sort -n "$stressfail")
385 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
386 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
387 done
388 rm -rf "$TRASH_DIRECTORY.stress-failed"
389 # Move the last one.
390 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
393 exit $stress_exit
396 # if --tee was passed, write the output not only to the terminal, but
397 # additionally to the file test-results/$BASENAME.out, too.
398 if test "$GIT_TEST_TEE_STARTED" = "done"
399 then
400 : # do not redirect again
401 elif test -n "$tee"
402 then
403 mkdir -p "$TEST_RESULTS_DIR"
405 # Make this filename available to the sub-process in case it is using
406 # --verbose-log.
407 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
408 export GIT_TEST_TEE_OUTPUT_FILE
410 # Truncate before calling "tee -a" to get rid of the results
411 # from any previous runs.
412 >"$GIT_TEST_TEE_OUTPUT_FILE"
414 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
415 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
416 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
417 exit
420 if test -n "$trace" && test -n "$test_untraceable"
421 then
422 # '-x' tracing requested, but this test script can't be reliably
423 # traced, unless it is run with a Bash version supporting
424 # BASH_XTRACEFD (introduced in Bash v4.1).
426 # Perform this version check _after_ the test script was
427 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
428 # '--verbose-log', so the right shell is checked and the
429 # warning is issued only once.
430 if test -n "$BASH_VERSION" && eval '
431 test ${BASH_VERSINFO[0]} -gt 4 || {
432 test ${BASH_VERSINFO[0]} -eq 4 &&
433 test ${BASH_VERSINFO[1]} -ge 1
436 then
437 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
438 else
439 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
440 trace=
443 if test -n "$trace" && test -z "$verbose_log"
444 then
445 verbose=t
448 # Since bash 5.0, checkwinsize is enabled by default which does
449 # update the COLUMNS variable every time a non-builtin command
450 # completes, even for non-interactive shells.
451 # Disable that since we are aiming for repeatability.
452 test -n "$BASH_VERSION" && shopt -u checkwinsize 2>/dev/null
454 # For repeatability, reset the environment to known value.
455 # TERM is sanitized below, after saving color control sequences.
456 LANG=C
457 LC_ALL=C
458 PAGER=cat
459 TZ=UTC
460 COLUMNS=80
461 export LANG LC_ALL PAGER TZ COLUMNS
462 EDITOR=:
464 # A call to "unset" with no arguments causes at least Solaris 10
465 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
466 # deriving from the command substitution clustered with the other
467 # ones.
468 unset VISUAL EMAIL LANGUAGE $("$PERL_PATH" -e '
469 my @env = keys %ENV;
470 my $ok = join("|", qw(
471 TRACE
472 DEBUG
473 TEST
474 .*_TEST
475 PROVE
476 VALGRIND
477 UNZIP
478 PERF_
479 CURL_VERBOSE
480 TRACE_CURL
482 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
483 print join("\n", @vars);
485 unset XDG_CACHE_HOME
486 unset XDG_CONFIG_HOME
487 unset GITPERLLIB
488 unset GIT_TRACE2_PARENT_NAME
489 unset GIT_TRACE2_PARENT_SID
490 TEST_AUTHOR_LOCALNAME=author
491 TEST_AUTHOR_DOMAIN=example.com
492 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
493 GIT_AUTHOR_NAME='A U Thor'
494 GIT_AUTHOR_DATE='1112354055 +0200'
495 TEST_COMMITTER_LOCALNAME=committer
496 TEST_COMMITTER_DOMAIN=example.com
497 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
498 GIT_COMMITTER_NAME='C O Mitter'
499 GIT_COMMITTER_DATE='1112354055 +0200'
500 GIT_MERGE_VERBOSITY=5
501 GIT_MERGE_AUTOEDIT=no
502 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
503 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
504 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
505 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
506 export EDITOR
508 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
509 export GIT_DEFAULT_HASH
510 GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
511 export GIT_TEST_MERGE_ALGORITHM
513 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
514 GIT_TRACE_BARE=1
515 export GIT_TRACE_BARE
517 # Some tests scan the GIT_TRACE2_EVENT feed for events, but the
518 # default depth is 2, which frequently causes issues when the
519 # events are wrapped in new regions. Set it to a sufficiently
520 # large depth to avoid custom changes in the test suite.
521 GIT_TRACE2_EVENT_NESTING=100
522 export GIT_TRACE2_EVENT_NESTING
524 # Use specific version of the index file format
525 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
526 then
527 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
528 export GIT_INDEX_VERSION
531 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
532 then
533 GIT_PERL_FATAL_WARNINGS=1
534 export GIT_PERL_FATAL_WARNINGS
537 case $GIT_TEST_FSYNC in
539 GIT_TEST_FSYNC=0
540 export GIT_TEST_FSYNC
542 esac
544 # Add libc MALLOC and MALLOC_PERTURB test only if we are not executing
545 # the test with valgrind and have not compiled with SANITIZE=address.
546 if test -n "$valgrind" ||
547 test -n "$SANITIZE_ADDRESS" ||
548 test -n "$TEST_NO_MALLOC_CHECK"
549 then
550 setup_malloc_check () {
551 : nothing
553 teardown_malloc_check () {
554 : nothing
556 else
557 setup_malloc_check () {
558 local g
559 local t
560 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
561 export MALLOC_CHECK_ MALLOC_PERTURB_
562 if _GLIBC_VERSION=$(getconf GNU_LIBC_VERSION 2>/dev/null) &&
563 _GLIBC_VERSION=${_GLIBC_VERSION#"glibc "} &&
564 expr 2.34 \<= "$_GLIBC_VERSION" >/dev/null
565 then
567 LD_PRELOAD="libc_malloc_debug.so.0"
568 for t in \
569 glibc.malloc.check=1 \
570 glibc.malloc.perturb=165
572 g="${g#:}:$t"
573 done
574 GLIBC_TUNABLES=$g
575 export LD_PRELOAD GLIBC_TUNABLES
578 teardown_malloc_check () {
579 unset MALLOC_CHECK_ MALLOC_PERTURB_
580 unset LD_PRELOAD GLIBC_TUNABLES
584 # Protect ourselves from common misconfiguration to export
585 # CDPATH into the environment
586 unset CDPATH
588 unset GREP_OPTIONS
589 unset UNZIP
591 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
592 1|2|true)
593 GIT_TRACE=4
595 esac
597 # Line feed
598 LF='
601 # Single quote
602 SQ=\'
604 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
605 # when case-folding filenames
606 u200c=$(printf '\342\200\214')
608 export _x05 _x35 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
610 # Each test should start with something like this, after copyright notices:
612 # test_description='Description of this test...
613 # This test checks if command xyzzy does the right thing...
615 # . ./test-lib.sh
616 test "x$TERM" != "xdumb" && (
617 test -t 1 &&
618 tput bold >/dev/null 2>&1 &&
619 tput setaf 1 >/dev/null 2>&1 &&
620 tput sgr0 >/dev/null 2>&1
621 ) &&
622 color=t
624 if test -n "$color"
625 then
626 # Save the color control sequences now rather than run tput
627 # each time say_color() is called. This is done for two
628 # reasons:
629 # * TERM will be changed to dumb
630 # * HOME will be changed to a temporary directory and tput
631 # might need to read ~/.terminfo from the original HOME
632 # directory to get the control sequences
633 # Note: This approach assumes the control sequences don't end
634 # in a newline for any terminal of interest (command
635 # substitutions strip trailing newlines). Given that most
636 # (all?) terminals in common use are related to ECMA-48, this
637 # shouldn't be a problem.
638 say_color_error=$(tput bold; tput setaf 1) # bold red
639 say_color_skip=$(tput setaf 4) # blue
640 say_color_warn=$(tput setaf 3) # brown/yellow
641 say_color_pass=$(tput setaf 2) # green
642 say_color_info=$(tput setaf 6) # cyan
643 say_color_reset=$(tput sgr0)
644 say_color_="" # no formatting for normal text
645 say_color () {
646 test -z "$1" && test -n "$quiet" && return
647 eval "say_color_color=\$say_color_$1"
648 shift
649 printf "%s\\n" "$say_color_color$*$say_color_reset"
651 else
652 say_color() {
653 test -z "$1" && test -n "$quiet" && return
654 shift
655 printf "%s\n" "$*"
659 USER_TERM="$TERM"
660 TERM=dumb
661 export TERM USER_TERM
663 # What is written by tests to stdout and stderr is sent to different places
664 # depending on the test mode (e.g. /dev/null in non-verbose mode, piped to tee
665 # with --tee option, etc.). We save the original stdin to FD #6 and stdout and
666 # stderr to #5 and #7, so that the test framework can use them (e.g. for
667 # printing errors within the test framework) independently of the test mode.
668 exec 5>&1
669 exec 6<&0
670 exec 7>&2
672 _error_exit () {
673 finalize_test_output
674 GIT_EXIT_OK=t
675 exit 1
678 error () {
679 say_color error "error: $*"
680 _error_exit
683 BUG () {
684 error >&7 "bug in the test script: $*"
687 BAIL_OUT () {
688 test $# -ne 1 && BUG "1 param"
690 # Do not change "Bail out! " string. It's part of TAP syntax:
691 # https://testanything.org/tap-specification.html
692 local bail_out="Bail out! "
693 local message="$1"
695 say_color >&5 error $bail_out "$message"
696 _error_exit
699 say () {
700 say_color info "$*"
703 if test -n "$HARNESS_ACTIVE"
704 then
705 if test "$verbose" = t || test -n "$verbose_only"
706 then
707 BAIL_OUT 'verbose mode forbidden under TAP harness; try --verbose-log'
711 test "${test_description}" != "" ||
712 error "Test script did not set test_description."
714 if test "$help" = "t"
715 then
716 printf '%s\n' "$test_description"
717 exit 0
720 if test "$verbose_log" = "t"
721 then
722 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
723 elif test "$verbose" = "t"
724 then
725 exec 4>&2 3>&1
726 else
727 exec 4>/dev/null 3>/dev/null
730 # Send any "-x" output directly to stderr to avoid polluting tests
731 # which capture stderr. We can do this unconditionally since it
732 # has no effect if tracing isn't turned on.
734 # Note that this sets up the trace fd as soon as we assign the variable, so it
735 # must come after the creation of descriptor 4 above. Likewise, we must never
736 # unset this, as it has the side effect of closing descriptor 4, which we
737 # use to show verbose tests to the user.
739 # Note also that we don't need or want to export it. The tracing is local to
740 # this shell, and we would not want to influence any shells we exec.
741 BASH_XTRACEFD=4
743 test_failure=0
744 test_count=0
745 test_fixed=0
746 test_broken=0
747 test_success=0
749 test_missing_prereq=
751 test_external_has_tap=0
753 die () {
754 code=$?
755 # This is responsible for running the atexit commands even when a
756 # test script run with '--immediate' fails, or when the user hits
757 # ctrl-C, i.e. when 'test_done' is not invoked at all.
758 test_atexit_handler || code=$?
759 if test -n "$GIT_EXIT_OK"
760 then
761 exit $code
762 else
763 echo >&5 "FATAL: Unexpected exit with code $code"
764 exit 1
768 GIT_EXIT_OK=
769 trap 'die' EXIT
770 # Disable '-x' tracing, because with some shells, notably dash, it
771 # prevents running the cleanup commands when a test script run with
772 # '--verbose-log -x' is interrupted.
773 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
775 # The user-facing functions are loaded from a separate file so that
776 # test_perf subshells can have them too
777 . "$TEST_DIRECTORY/test-lib-functions.sh"
779 # You are not expected to call test_ok_ and test_failure_ directly, use
780 # the test_expect_* functions instead.
782 test_ok_ () {
783 finalize_test_case_output ok "$@"
784 test_success=$(($test_success + 1))
785 say_color "" "ok $test_count - $@"
788 test_failure_ () {
789 finalize_test_case_output failure "$@"
790 test_failure=$(($test_failure + 1))
791 say_color error "not ok $test_count - $1"
792 shift
793 printf '%s\n' "$*" | sed -e 's/^/# /'
794 if test -n "$immediate"
795 then
796 say_color error "1..$test_count"
797 _error_exit
801 test_known_broken_ok_ () {
802 finalize_test_case_output fixed "$@"
803 test_fixed=$(($test_fixed+1))
804 say_color error "ok $test_count - $@ # TODO known breakage vanished"
807 test_known_broken_failure_ () {
808 finalize_test_case_output broken "$@"
809 test_broken=$(($test_broken+1))
810 say_color warn "not ok $test_count - $@ # TODO known breakage"
813 test_debug () {
814 test "$debug" = "" || eval "$1"
817 match_pattern_list () {
818 arg="$1"
819 shift
820 test -z "$*" && return 1
821 # We need to use "$*" to get field-splitting, but we want to
822 # disable globbing, since we are matching against an arbitrary
823 # $arg, not what's in the filesystem. Using "set -f" accomplishes
824 # that, but we must do it in a subshell to avoid impacting the
825 # rest of the script. The exit value of the subshell becomes
826 # the function's return value.
828 set -f
829 for pattern_ in $*
831 case "$arg" in
832 $pattern_)
833 exit 0
835 esac
836 done
837 exit 1
841 match_test_selector_list () {
842 operation="$1"
843 shift
844 title="$1"
845 shift
846 arg="$1"
847 shift
848 test -z "$1" && return 0
850 # Commas are accepted as separators.
851 OLDIFS=$IFS
852 IFS=','
853 set -- $1
854 IFS=$OLDIFS
856 # If the first selector is negative we include by default.
857 include=
858 case "$1" in
859 !*) include=t ;;
860 esac
862 for selector
864 orig_selector=$selector
866 positive=t
867 case "$selector" in
869 positive=
870 selector=${selector##?}
872 esac
874 test -z "$selector" && continue
876 case "$selector" in
877 *-*)
878 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
879 then
880 echo "error: $operation: invalid non-numeric in range" \
881 "start: '$orig_selector'" >&2
882 exit 1
884 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
885 then
886 echo "error: $operation: invalid non-numeric in range" \
887 "end: '$orig_selector'" >&2
888 exit 1
892 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
893 then
894 case "$title" in *${selector}*)
895 include=$positive
897 esac
898 continue
900 esac
902 # Short cut for "obvious" cases
903 test -z "$include" && test -z "$positive" && continue
904 test -n "$include" && test -n "$positive" && continue
906 case "$selector" in
908 if test $arg -le ${selector#-}
909 then
910 include=$positive
914 if test $arg -ge ${selector%-}
915 then
916 include=$positive
919 *-*)
920 if test ${selector%%-*} -le $arg \
921 && test $arg -le ${selector#*-}
922 then
923 include=$positive
927 if test $arg -eq $selector
928 then
929 include=$positive
932 esac
933 done
935 test -n "$include"
938 maybe_teardown_verbose () {
939 test -z "$verbose_only" && return
940 exec 4>/dev/null 3>/dev/null
941 verbose=
944 last_verbose=t
945 maybe_setup_verbose () {
946 test -z "$verbose_only" && return
947 if match_pattern_list $test_count "$verbose_only"
948 then
949 exec 4>&2 3>&1
950 # Emit a delimiting blank line when going from
951 # non-verbose to verbose. Within verbose mode the
952 # delimiter is printed by test_expect_*. The choice
953 # of the initial $last_verbose is such that before
954 # test 1, we do not print it.
955 test -z "$last_verbose" && echo >&3 ""
956 verbose=t
957 else
958 exec 4>/dev/null 3>/dev/null
959 verbose=
961 last_verbose=$verbose
964 maybe_teardown_valgrind () {
965 test -z "$GIT_VALGRIND" && return
966 GIT_VALGRIND_ENABLED=
969 maybe_setup_valgrind () {
970 test -z "$GIT_VALGRIND" && return
971 if test -z "$valgrind_only"
972 then
973 GIT_VALGRIND_ENABLED=t
974 return
976 GIT_VALGRIND_ENABLED=
977 if match_pattern_list $test_count "$valgrind_only"
978 then
979 GIT_VALGRIND_ENABLED=t
983 trace_level_=0
984 want_trace () {
985 test "$trace" = t && {
986 test "$verbose" = t || test "$verbose_log" = t
990 # This is a separate function because some tests use
991 # "return" to end a test_expect_success block early
992 # (and we want to make sure we run any cleanup like
993 # "set +x").
994 test_eval_inner_ () {
995 # Do not add anything extra (including LF) after '$*'
996 eval "
997 want_trace && trace_level_=$(($trace_level_+1)) && set -x
1001 test_eval_ () {
1002 # If "-x" tracing is in effect, then we want to avoid polluting stderr
1003 # with non-test commands. But once in "set -x" mode, we cannot prevent
1004 # the shell from printing the "set +x" to turn it off (nor the saving
1005 # of $? before that). But we can make sure that the output goes to
1006 # /dev/null.
1008 # There are a few subtleties here:
1010 # - we have to redirect descriptor 4 in addition to 2, to cover
1011 # BASH_XTRACEFD
1013 # - the actual eval has to come before the redirection block (since
1014 # it needs to see descriptor 4 to set up its stderr)
1016 # - likewise, any error message we print must be outside the block to
1017 # access descriptor 4
1019 # - checking $? has to come immediately after the eval, but it must
1020 # be _inside_ the block to avoid polluting the "set -x" output
1023 test_eval_inner_ "$@" </dev/null >&3 2>&4
1025 test_eval_ret_=$?
1026 if want_trace
1027 then
1028 test 1 = $trace_level_ && set +x
1029 trace_level_=$(($trace_level_-1))
1031 } 2>/dev/null 4>&2
1033 if test "$test_eval_ret_" != 0 && want_trace
1034 then
1035 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
1037 return $test_eval_ret_
1040 test_run_ () {
1041 test_cleanup=:
1042 expecting_failure=$2
1044 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
1045 # turn off tracing for this test-eval, as it simply creates
1046 # confusing noise in the "-x" output
1047 trace_tmp=$trace
1048 trace=
1049 # 117 is magic because it is unlikely to match the exit
1050 # code of other programs
1051 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)" ||
1053 test "${GIT_TEST_CHAIN_LINT_HARDER:-${GIT_TEST_CHAIN_LINT_HARDER_DEFAULT:-1}}" != 0 &&
1054 $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!')
1056 then
1057 BUG "broken &&-chain or run-away HERE-DOC: $1"
1059 trace=$trace_tmp
1062 setup_malloc_check
1063 test_eval_ "$1"
1064 eval_ret=$?
1065 teardown_malloc_check
1067 if test -z "$immediate" || test $eval_ret = 0 ||
1068 test -n "$expecting_failure" && test "$test_cleanup" != ":"
1069 then
1070 setup_malloc_check
1071 test_eval_ "$test_cleanup"
1072 teardown_malloc_check
1074 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1075 then
1076 echo ""
1078 return "$eval_ret"
1081 test_start_ () {
1082 test_count=$(($test_count+1))
1083 maybe_setup_verbose
1084 maybe_setup_valgrind
1085 start_test_case_output
1088 test_finish_ () {
1089 echo >&3 ""
1090 maybe_teardown_valgrind
1091 maybe_teardown_verbose
1092 if test -n "$GIT_TEST_TEE_OFFSET"
1093 then
1094 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1095 "$GIT_TEST_TEE_OUTPUT_FILE")
1099 test_skip () {
1100 to_skip=
1101 skipped_reason=
1102 if match_pattern_list $this_test.$test_count "$GIT_SKIP_TESTS"
1103 then
1104 to_skip=t
1105 skipped_reason="GIT_SKIP_TESTS"
1107 if test -z "$to_skip" && test -n "$run_list" &&
1108 ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1109 then
1110 to_skip=t
1111 skipped_reason="--run"
1113 if test -z "$to_skip" && test -n "$test_prereq" &&
1114 ! test_have_prereq "$test_prereq"
1115 then
1116 to_skip=t
1118 of_prereq=
1119 if test "$missing_prereq" != "$test_prereq"
1120 then
1121 of_prereq=" of $test_prereq"
1123 skipped_reason="missing $missing_prereq${of_prereq}"
1125 # Keep a list of all the missing prereq for result aggregation
1126 if test -z "$missing_prereq"
1127 then
1128 test_missing_prereq=$missing_prereq
1129 else
1130 test_missing_prereq="$test_missing_prereq,$missing_prereq"
1134 case "$to_skip" in
1136 finalize_test_case_output skip "$@"
1138 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1139 : true
1142 false
1144 esac
1147 # stub; perf-lib overrides it
1148 test_at_end_hook_ () {
1152 test_atexit_cleanup=:
1153 test_atexit_handler () {
1154 # In a succeeding test script 'test_atexit_handler' is invoked
1155 # twice: first from 'test_done', then from 'die' in the trap on
1156 # EXIT.
1157 # This condition and resetting 'test_atexit_cleanup' below makes
1158 # sure that the registered cleanup commands are run only once.
1159 test : != "$test_atexit_cleanup" || return 0
1161 setup_malloc_check
1162 test_eval_ "$test_atexit_cleanup"
1163 test_atexit_cleanup=:
1164 teardown_malloc_check
1167 test_done () {
1168 GIT_EXIT_OK=t
1170 # Run the atexit commands _before_ the trash directory is
1171 # removed, so the commands can access pidfiles and socket files.
1172 test_atexit_handler
1174 finalize_test_output
1176 if test -z "$HARNESS_ACTIVE"
1177 then
1178 mkdir -p "$TEST_RESULTS_DIR"
1180 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1181 total $test_count
1182 success $test_success
1183 fixed $test_fixed
1184 broken $test_broken
1185 failed $test_failure
1186 missing_prereq $test_missing_prereq
1191 if test "$test_fixed" != 0
1192 then
1193 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1195 if test "$test_broken" != 0
1196 then
1197 say_color warn "# still have $test_broken known breakage(s)"
1199 if test "$test_broken" != 0 || test "$test_fixed" != 0
1200 then
1201 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1202 msg="remaining $test_remaining test(s)"
1203 else
1204 test_remaining=$test_count
1205 msg="$test_count test(s)"
1207 case "$test_failure" in
1209 if test $test_external_has_tap -eq 0
1210 then
1211 if test $test_remaining -gt 0
1212 then
1213 say_color pass "# passed all $msg"
1216 # Maybe print SKIP message
1217 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1218 case "$test_count" in
1220 say "1..$test_count${skip_all:+ $skip_all}"
1223 test -z "$skip_all" ||
1224 say_color warn "$skip_all"
1225 say "1..$test_count"
1227 esac
1230 if test -z "$debug" && test -n "$remove_trash"
1231 then
1232 test -d "$TRASH_DIRECTORY" ||
1233 error "Tests passed but trash directory already removed before test cleanup; aborting"
1235 cd "$TRASH_DIRECTORY/.." &&
1236 rm -fr "$TRASH_DIRECTORY" || {
1237 # try again in a bit
1238 sleep 5;
1239 rm -fr "$TRASH_DIRECTORY"
1240 } ||
1241 error "Tests passed but test cleanup failed; aborting"
1243 test_at_end_hook_
1245 exit 0 ;;
1248 if test $test_external_has_tap -eq 0
1249 then
1250 say_color error "# failed $test_failure among $msg"
1251 say "1..$test_count"
1254 exit 1 ;;
1256 esac
1259 if test -n "$valgrind"
1260 then
1261 make_symlink () {
1262 test -h "$2" &&
1263 test "$1" = "$(readlink "$2")" || {
1264 # be super paranoid
1265 if mkdir "$2".lock
1266 then
1267 rm -f "$2" &&
1268 ln -s "$1" "$2" &&
1269 rm -r "$2".lock
1270 else
1271 while test -d "$2".lock
1273 say "Waiting for lock on $2."
1274 sleep 1
1275 done
1280 make_valgrind_symlink () {
1281 # handle only executables, unless they are shell libraries that
1282 # need to be in the exec-path.
1283 test -x "$1" ||
1284 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1285 return;
1287 base=$(basename "$1")
1288 case "$base" in
1289 test-*)
1290 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1293 symlink_target="$GIT_BUILD_DIR/$base"
1295 esac
1296 # do not override scripts
1297 if test -x "$symlink_target" &&
1298 test ! -d "$symlink_target" &&
1299 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1300 then
1301 symlink_target=../valgrind.sh
1303 case "$base" in
1304 *.sh|*.perl)
1305 symlink_target=../unprocessed-script
1306 esac
1307 # create the link, or replace it if it is out of date
1308 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1311 # override all git executables in TEST_DIRECTORY/..
1312 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1313 mkdir -p "$GIT_VALGRIND"/bin
1314 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1316 make_valgrind_symlink $file
1317 done
1318 # special-case the mergetools loadables
1319 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1320 OLDIFS=$IFS
1321 IFS=:
1322 for path in $PATH
1324 ls "$path"/git-* 2> /dev/null |
1325 while read file
1327 make_valgrind_symlink "$file"
1328 done
1329 done
1330 IFS=$OLDIFS
1331 PATH=$GIT_VALGRIND/bin:$PATH
1332 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1333 export GIT_VALGRIND
1334 GIT_VALGRIND_MODE="$valgrind"
1335 export GIT_VALGRIND_MODE
1336 GIT_VALGRIND_ENABLED=t
1337 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1338 export GIT_VALGRIND_ENABLED
1339 elif test -n "$GIT_TEST_INSTALLED"
1340 then
1341 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1342 error "Cannot run git from $GIT_TEST_INSTALLED."
1343 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1344 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1345 else # normal case, use ../bin-wrappers only unless $with_dashes:
1346 if test -n "$no_bin_wrappers"
1347 then
1348 with_dashes=t
1349 else
1350 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1351 if ! test -x "$git_bin_dir/git"
1352 then
1353 if test -z "$with_dashes"
1354 then
1355 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1357 with_dashes=t
1359 PATH="$git_bin_dir:$PATH"
1361 GIT_EXEC_PATH=$GIT_BUILD_DIR
1362 if test -n "$with_dashes"
1363 then
1364 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1367 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1368 GIT_CONFIG_NOSYSTEM=1
1369 GIT_ATTR_NOSYSTEM=1
1370 GIT_CEILING_DIRECTORIES="$TRASH_DIRECTORY/.."
1371 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM GIT_CEILING_DIRECTORIES
1373 if test -z "$GIT_TEST_CMP"
1374 then
1375 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1376 then
1377 GIT_TEST_CMP="$DIFF -c"
1378 else
1379 GIT_TEST_CMP="$DIFF -u"
1383 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1384 export GITPERLLIB
1385 test -d "$GIT_BUILD_DIR"/templates/blt || {
1386 error "You haven't built things yet, have you?"
1389 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1390 then
1391 echo >&2 'You need to build test-tool:'
1392 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1393 exit 1
1396 # Are we running this test at all?
1397 remove_trash=
1398 this_test=${0##*/}
1399 this_test=${this_test%%-*}
1400 if match_pattern_list "$this_test" "$GIT_SKIP_TESTS"
1401 then
1402 say_color info >&3 "skipping test $this_test altogether"
1403 skip_all="skip all tests in $this_test"
1404 test_done
1407 # skip non-whitelisted tests when compiled with SANITIZE=leak
1408 if test -n "$SANITIZE_LEAK"
1409 then
1410 if test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1411 then
1412 # We need to see it in "git env--helper" (via
1413 # test_bool_env)
1414 export TEST_PASSES_SANITIZE_LEAK
1416 if ! test_bool_env TEST_PASSES_SANITIZE_LEAK false
1417 then
1418 skip_all="skipping $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=true"
1419 test_done
1422 elif test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1423 then
1424 BAIL_OUT "GIT_TEST_PASSING_SANITIZE_LEAK=true has no effect except when compiled with SANITIZE=leak"
1427 # Last-minute variable setup
1428 USER_HOME="$HOME"
1429 HOME="$TRASH_DIRECTORY"
1430 GNUPGHOME="$HOME/gnupg-home-not-used"
1431 export HOME GNUPGHOME USER_HOME
1433 # "rm -rf" existing trash directory, even if a previous run left it
1434 # with bad permissions.
1435 remove_trash_directory () {
1436 dir="$1"
1437 if ! rm -rf "$dir" 2>/dev/null
1438 then
1439 chmod -R u+rwx "$dir"
1440 rm -rf "$dir"
1442 ! test -d "$dir"
1445 # Test repository
1446 remove_trash_directory "$TRASH_DIRECTORY" || {
1447 GIT_EXIT_OK=t
1448 echo >&5 "FATAL: Cannot prepare test area"
1449 exit 1
1452 remove_trash=t
1453 if test -z "$TEST_NO_CREATE_REPO"
1454 then
1455 git init "$TRASH_DIRECTORY" >&3 2>&4 ||
1456 error "cannot run git init"
1457 else
1458 mkdir -p "$TRASH_DIRECTORY"
1461 # Use -P to resolve symlinks in our working directory so that the cwd
1462 # in subprocesses like git equals our $PWD (for pathname comparisons).
1463 cd -P "$TRASH_DIRECTORY" || exit 1
1465 start_test_output "$0"
1467 # Convenience
1468 # A regexp to match 5 and 35 hexdigits
1469 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1470 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1472 test_oid_init
1474 ZERO_OID=$(test_oid zero)
1475 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1476 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1477 EMPTY_TREE=$(test_oid empty_tree)
1478 EMPTY_BLOB=$(test_oid empty_blob)
1480 # Provide an implementation of the 'yes' utility; the upper bound
1481 # limit is there to help Windows that cannot stop this loop from
1482 # wasting cycles when the downstream stops reading, so do not be
1483 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1484 # limit the output of the yes utility", 2016-02-02)
1485 yes () {
1486 if test $# = 0
1487 then
1489 else
1490 y="$*"
1494 while test $i -lt 99
1496 echo "$y"
1497 i=$(($i+1))
1498 done
1501 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1502 # thus needs to be set up really early, and set an internal variable
1503 # for convenience so the hot test_set_prereq() codepath doesn't need
1504 # to call "git env--helper" (via test_bool_env). Only do that work
1505 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1506 GIT_TEST_FAIL_PREREQS_INTERNAL=
1507 if test -n "$GIT_TEST_FAIL_PREREQS"
1508 then
1509 if test_bool_env GIT_TEST_FAIL_PREREQS false
1510 then
1511 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1512 test_set_prereq FAIL_PREREQS
1514 else
1515 test_lazy_prereq FAIL_PREREQS '
1516 test_bool_env GIT_TEST_FAIL_PREREQS false
1520 # Fix some commands on Windows, and other OS-specific things
1521 uname_s=$(uname -s)
1522 case $uname_s in
1523 *MINGW*)
1524 # Windows has its own (incompatible) sort and find
1525 sort () {
1526 /usr/bin/sort "$@"
1528 find () {
1529 /usr/bin/find "$@"
1531 # git sees Windows-style pwd
1532 pwd () {
1533 builtin pwd -W
1535 # no POSIX permissions
1536 # backslashes in pathspec are converted to '/'
1537 # exec does not inherit the PID
1538 test_set_prereq MINGW
1539 test_set_prereq NATIVE_CRLF
1540 test_set_prereq SED_STRIPS_CR
1541 test_set_prereq GREP_STRIPS_CR
1542 test_set_prereq WINDOWS
1543 GIT_TEST_CMP=mingw_test_cmp
1545 *CYGWIN*)
1546 test_set_prereq POSIXPERM
1547 test_set_prereq EXECKEEPSPID
1548 test_set_prereq CYGWIN
1549 test_set_prereq SED_STRIPS_CR
1550 test_set_prereq GREP_STRIPS_CR
1551 test_set_prereq WINDOWS
1554 test_set_prereq POSIXPERM
1555 test_set_prereq BSLASHPSPEC
1556 test_set_prereq EXECKEEPSPID
1558 esac
1560 # Detect arches where a few things don't work
1561 uname_m=$(uname -m)
1562 case $uname_m in
1563 parisc* | hppa*)
1564 test_set_prereq HPPA
1566 esac
1568 test_set_prereq REFFILES
1570 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1571 test -z "$NO_PERL" && test_set_prereq PERL
1572 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1573 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1574 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1575 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1576 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1577 test -n "$SANITIZE_LEAK" && test_set_prereq SANITIZE_LEAK
1579 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1580 then
1581 GIT_TEST_CHECK_CACHE_TREE=true
1582 export GIT_TEST_CHECK_CACHE_TREE
1585 test_lazy_prereq PIPE '
1586 # test whether the filesystem supports FIFOs
1587 test_have_prereq !MINGW,!CYGWIN &&
1588 rm -f testfifo && mkfifo testfifo
1591 test_lazy_prereq SYMLINKS '
1592 # test whether the filesystem supports symbolic links
1593 ln -s x y && test -h y
1596 test_lazy_prereq SYMLINKS_WINDOWS '
1597 # test whether symbolic links are enabled on Windows
1598 test_have_prereq MINGW &&
1599 cmd //c "mklink y x" &> /dev/null && test -h y
1602 test_lazy_prereq FILEMODE '
1603 test "$(git config --bool core.filemode)" = true
1606 test_lazy_prereq CASE_INSENSITIVE_FS '
1607 echo good >CamelCase &&
1608 echo bad >camelcase &&
1609 test "$(cat CamelCase)" != good
1612 test_lazy_prereq FUNNYNAMES '
1613 test_have_prereq !MINGW &&
1614 touch -- \
1615 "FUNNYNAMES tab embedded" \
1616 "FUNNYNAMES \"quote embedded\"" \
1617 "FUNNYNAMES newline
1618 embedded" 2>/dev/null &&
1619 rm -- \
1620 "FUNNYNAMES tab embedded" \
1621 "FUNNYNAMES \"quote embedded\"" \
1622 "FUNNYNAMES newline
1623 embedded" 2>/dev/null
1626 test_lazy_prereq UTF8_NFD_TO_NFC '
1627 # check whether FS converts nfd unicode to nfc
1628 auml=$(printf "\303\244")
1629 aumlcdiar=$(printf "\141\314\210")
1630 >"$auml" &&
1631 test -f "$aumlcdiar"
1634 test_lazy_prereq AUTOIDENT '
1635 sane_unset GIT_AUTHOR_NAME &&
1636 sane_unset GIT_AUTHOR_EMAIL &&
1637 git var GIT_AUTHOR_IDENT
1640 test_lazy_prereq EXPENSIVE '
1641 test -n "$GIT_TEST_LONG"
1644 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1645 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1648 test_lazy_prereq USR_BIN_TIME '
1649 test -x /usr/bin/time
1652 test_lazy_prereq NOT_ROOT '
1653 uid=$(id -u) &&
1654 test "$uid" != 0
1657 test_lazy_prereq JGIT '
1658 jgit --version
1661 # SANITY is about "can you correctly predict what the filesystem would
1662 # do by only looking at the permission bits of the files and
1663 # directories?" A typical example of !SANITY is running the test
1664 # suite as root, where a test may expect "chmod -r file && cat file"
1665 # to fail because file is supposed to be unreadable after a successful
1666 # chmod. In an environment (i.e. combination of what filesystem is
1667 # being used and who is running the tests) that lacks SANITY, you may
1668 # be able to delete or create a file when the containing directory
1669 # doesn't have write permissions, or access a file even if the
1670 # containing directory doesn't have read or execute permissions.
1672 test_lazy_prereq SANITY '
1673 mkdir SANETESTD.1 SANETESTD.2 &&
1675 chmod +w SANETESTD.1 SANETESTD.2 &&
1676 >SANETESTD.1/x 2>SANETESTD.2/x &&
1677 chmod -w SANETESTD.1 &&
1678 chmod -r SANETESTD.1/x &&
1679 chmod -rx SANETESTD.2 ||
1680 BUG "cannot prepare SANETESTD"
1682 ! test -r SANETESTD.1/x &&
1683 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1684 status=$?
1686 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1687 rm -rf SANETESTD.1 SANETESTD.2 ||
1688 BUG "cannot clean SANETESTD"
1689 return $status
1692 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1693 GIT_UNZIP=${GIT_UNZIP:-unzip}
1694 test_lazy_prereq UNZIP '
1695 "$GIT_UNZIP" -v
1696 test $? -ne 127
1699 run_with_limited_cmdline () {
1700 (ulimit -s 128 && "$@")
1703 test_lazy_prereq CMDLINE_LIMIT '
1704 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1705 run_with_limited_cmdline true
1708 run_with_limited_stack () {
1709 (ulimit -s 128 && "$@")
1712 test_lazy_prereq ULIMIT_STACK_SIZE '
1713 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1714 run_with_limited_stack true
1717 run_with_limited_open_files () {
1718 (ulimit -n 32 && "$@")
1721 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1722 test_have_prereq !MINGW,!CYGWIN &&
1723 run_with_limited_open_files true
1726 build_option () {
1727 git version --build-options |
1728 sed -ne "s/^$1: //p"
1731 test_lazy_prereq SIZE_T_IS_64BIT '
1732 test 8 -eq "$(build_option sizeof-size_t)"
1735 test_lazy_prereq LONG_IS_64BIT '
1736 test 8 -le "$(build_option sizeof-long)"
1739 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1740 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1742 test_lazy_prereq CURL '
1743 curl --version
1746 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1747 # which will not work with other hash algorithms and tests that work but don't
1748 # test anything meaningful (e.g. special values which cause short collisions).
1749 test_lazy_prereq SHA1 '
1750 case "$GIT_DEFAULT_HASH" in
1751 sha1) true ;;
1752 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1753 *) false ;;
1754 esac
1757 # Ensure that no test accidentally triggers a Git command
1758 # that runs the actual maintenance scheduler, affecting a user's
1759 # system permanently.
1760 # Tests that verify the scheduler integration must set this locally
1761 # to avoid errors.
1762 GIT_TEST_MAINT_SCHEDULER="none:exit 1"
1764 # Does this platform support `git fsmonitor--daemon`
1766 test_lazy_prereq FSMONITOR_DAEMON '
1767 git version --build-options >output &&
1768 grep "feature: fsmonitor--daemon" output